﻿Imports System.IO
Public Class FBase

    ' Valores para tratar la lectura y la escitura de los datos
    Dim Carpeta As String
    Dim NombreFicheroDatos As String = "Liste.csv"
    Dim NombreYRutaFicheroDatos As String
    Dim FichierALire As StreamReader
    Dim FichierAEcrire As StreamWriter

    ' Valores para tratar datos CSV
    Dim LineaTMP As String
    Dim SeparadorSplit As Char() = {";"}   ' caracter separador de CSV, por defecto en XLS, puede ser otro
    Dim DttTMP() As String

    'Lista = Lista.csv : 0= Nombre; 1= Sigle; 2= Code; 3= Relacion; 4= ValAch; 5= DateAct; 6= ValAct; 7= Min1An; 8= Max1An; 9= Moneda
    Dim Lista As DataTable  ' Este es el DataTable para todos tratamientos
    Dim IndexActuel As Integer  ' Indicio actual,  para siempre saber cuale linea de datos es disponible

    Private Sub FBase_Load(sender As Object, e As EventArgs) Handles Me.Load
#If DEBUG Then
        Me.Carpeta = "D:\Tmp\DGVCarlosOK" & "\Datos\"
        TBFichDatos.Text = Carpeta & NombreFicheroDatos
#Else
        Me.Carpeta = CurDir() & "\Datos\"
        TBFichDatos.Text = Carpeta & "Liste.csv"
#End If

        IndexActuel = -1  ' Para siempre saber cuale linea de datos es disponible

        NombreYRutaFicheroDatos = TBFichDatos.Text

        ' Prepare DGV
        DGVLista.AllowUserToAddRows = True  ' Cuando es False, no existe una linea vacia a la fin del DGV. 
        DGVLista.AllowUserToOrderColumns = False
        DGVLista.ColumnHeadersVisible = True
        DGVLista.RowHeadersVisible = False
        DGVLista.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells '.DisplayedCells 
        DGVLista.MultiSelect = False

        DGVLista.SelectionMode = DataGridViewSelectionMode.FullRowSelect  ' atencion, este prohibe la selecion de una sola celda

        DGVLista.AutoSizeRowsMode = DataGridViewAutoSizeRowsMode.AllCells

        '      BCargarDatos_Click(Me, Nothing)    ' si queremos abrir en mismo tiempo que el programa
    End Sub

    Private Sub BFin_Click(sender As Object, e As EventArgs) Handles BFin.Click
        If Lista IsNot Nothing AndAlso Lista.GetChanges() IsNot Nothing Then  ' existe cambiadas
            Dim Reponse As DialogResult
            Reponse = MessageBox.Show("Modifcaciones no registardas" & vbCr & "Registrar ahora ?", "Atencion", MessageBoxButtons.YesNoCancel)
            If Reponse = DialogResult.Cancel Then
                Exit Sub
            ElseIf Reponse = DialogResult.Yes Then
                BRegistrarDatos_Click(Me, Nothing)  ' Vamos registrar
            End If
        End If
        End
    End Sub

    Private Sub FBase_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        BFin_Click(Me, Nothing)  ' Vamos verificar si existe datos no registrados
    End Sub

    Private Sub BorrarDatos()
        Try
            Lista.Clear()
            Lista.Dispose()
        Catch
        End Try
        DGVLista.DataSource = Nothing
        CBCol0.DataSource = Nothing
        LBCol1.DataSource = Nothing
        TBCol2.DataBindings.Clear()
    End Sub

    Private Sub BCargarDatos_Click(sender As Object, e As EventArgs) Handles BCargarDatos.Click
        If TBFichDatos.Text = String.Empty Then
            Exit Sub
        End If
        BorrarDatos()  ' Limpiar el DataTable Lista ante de lo llenar

        FichierALire = New StreamReader(NombreYRutaFicheroDatos, System.Text.Encoding.Default)
        Lista = New DataTable

        'Lectura de la linea con los nombres de los campos
        LineaTMP = FichierALire.ReadLine
        DttTMP = LineaTMP.Split(SeparadorSplit)
        For C As Integer = 0 To DttTMP.Count - 1
            Lista.Columns.Add(DttTMP(C))   ' crear las columnas en el DataTable
        Next
        'Lectura lineas con datos
        Do Until FichierALire.Peek = -1
            LineaTMP = FichierALire.ReadLine
            DttTMP = LineaTMP.Split(SeparadorSplit)
            Lista.Rows.Add(DttTMP)   ' agregar las lineas de datos
        Loop
        FichierALire.Close()
        FichierALire.Dispose()
        Lista.AcceptChanges()  ' Limpiar el DataTable de todas modificaciones precedentes, problamente no necesario aqui

        AfficheData()
    End Sub

    Private Sub BRegistrarDatos_Click(sender As Object, e As EventArgs) Handles BRegistrarDatos.Click
        If TBFichDatos.Text = String.Empty Then
            Exit Sub
        End If
        Lista.AcceptChanges()   ' Limpiar el DataTable de todas modificaciones precedentes
        FichierAEcrire = New StreamWriter(NombreYRutaFicheroDatos, False, System.Text.Encoding.Default)

        'Escritura de la linea con los nombres de los campos
        LineaTMP = ""
        For C As Integer = 0 To Lista.Columns.Count - 1
            LineaTMP &= Lista.Columns(C).ColumnName & IIf(C < Lista.Columns.Count - 1, SeparadorSplit, "")
        Next
        FichierAEcrire.WriteLine(LineaTMP)
        'Escritura lineas con datos
        For R As Integer = 0 To Lista.Rows.Count - 1
            LineaTMP = ""
            For C As Integer = 0 To Lista.Columns.Count - 1
                LineaTMP &= Lista.Rows(R).Item(C) & IIf(C < Lista.Columns.Count - 1, SeparadorSplit, "")
            Next
            FichierAEcrire.WriteLine(LineaTMP)
        Next
        FichierAEcrire.Close()
        FichierAEcrire.Dispose()

    End Sub

    Private Sub DGVLista_CellClick(sender As Object, e As DataGridViewCellEventArgs) Handles DGVLista.CellClick
        IndexActuel = e.RowIndex   ' para verificar nos pruebas
        TBIndex.Text = IndexActuel

    End Sub

    Private Sub AfficheData()

        'DGVLista es un DataGridView

        DGVLista.DataSource = Lista  ' Para ejemplo, todos campos


        'CBCol0 es un ComboBox

        CBCol0.DataSource = Lista
        CBCol0.DisplayMember = Lista.Columns(0).ColumnName  ' tambien podemos escribir  CBCol0.DisplayMember = Lista.Columns("Nombre")

        ' Para ComboBox, existe propiedead AutoComplete que no conozco
        ' https://learn.microsoft.com/fr-fr/dotnet/api/system.windows.forms.combobox.autocompletemode?view=windowsdesktop-7.0
        ' https://codes-sources.commentcamarche.net/forum/affich-1244480-vb-net-autocomplete 
        CBCol0.AutoCompleteMode = AutoCompleteMode.Suggest
        CBCol0.AutoCompleteSource = AutoCompleteSource.ListItems '.CustomSource

        'LBCol1 es un ListBox

        LBCol1.DataSource = Lista
        LBCol1.DisplayMember = Lista.Columns(1).ColumnName  ' tambien podemos escribir  CBCol0.DisplayMember = Lista.Columns("Sigle")

        'TBCol1 es un TextBox

        TBCol2.DataBindings.Add("Text", Lista, Lista.Columns(2).ColumnName)  ' tambien podemos escribir  CBCol0.DisplayMember = Lista.Columns("Code")

    End Sub

    ' El bloque de gestión de lectura. Un solo procedimiente evento responde a 4 fuentes de Click : BPrimero, BAnterior, BSiguiente y BUltimo
    Private Sub LecturaCircular_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BUltimo.Click, BAnterior.Click, BSiguiente.Click, BPrimero.Click
        ' No es necesario intentar un movimiento si el DataSet no contiene ninguna tabla.
        If Lista.Rows.Count > 0 Then
            ' El BindingContext pertenece a un contenedor, el formulario en este caso.
            With Me.BindingContext(Lista)
                ' Modificacion de la propiedad Position segun el boton seleccionado.
                Select Case sender.Name
                    Case "BPrimero"
                        .Position = 0
                    Case "BAnterior"
                        If .Position = 0 Then
                            .Position = .Count - 1              ' Lectura circular (como un reloj pero al revés)
                        Else
                            .Position -= 1
                        End If
                    Case "BSiguiente"
                        If .Position = .Count - 1 Then
                            .Position = 0                       ' Lectura circular (como un reloj)
                        Else
                            .Position += 1
                        End If
                    Case "BUltimo"
                        .Position = .Count - 1
                End Select
            End With
        End If
    End Sub

    ' Ejemplo para tener (o cambiar pôr el codigo) el valor de una celda
    Private Sub DGVLista_CellMouseDoubleClick(sender As Object, e As DataGridViewCellMouseEventArgs) Handles DGVLista.CellMouseDoubleClick
        MessageBox.Show(DGVLista.Item(e.ColumnIndex, e.RowIndex).Value)
    End Sub

    Private Sub DGVLista_CellEndEdit(sender As Object, e As DataGridViewCellEventArgs) Handles DGVLista.CellEndEdit
        If e.ColumnIndex = 0 And e.RowIndex = 0 Then  ' somos en la primera celda
            Dim CadenaBuscada As String = DGVLista.Item(e.ColumnIndex, e.RowIndex).Value

            '' Si buscas en todas columnas  *********************************
            'For R As Integer = 1 To DGVLista.Rows.Count - 2   ' escribir -1 si no existe linea vacia a la fin del DGV (AllowUersToAddRow = False)
            '    For C = 0 To DGVLista.Columns.Count - 1
            '        If DGVLista.Item(C, R).Value = CadenaBuscada  Then
            '            ' Tratar aqui el descubrimiento de una celda que contiene mismo texto que la celda 0,0 
            '            Exit Sub ' si no necesario de mirar el resto del DGV
            '        End If
            '    Next
            'Next

            ' Si buscas solamente en columna 0  *********************************   
            For R As Integer = 1 To DGVLista.Rows.Count - 2   ' escribir -1 si no existe linea vacia a la fin del DGV (AllowUersToAddRow = False)
                ' Si buscas en todas columnas
                If DGVLista.Item(0, R).Value = CadenaBuscada Then
                    ' Tratar aqui el descubrimiento de una linea que empeza con el mismo valor en columna 0  
                    ' Por mi prueba :
                    MessageBox.Show("Encontrar")
                    Exit Sub ' si no necesario de mirar el resto del DGV
                End If
            Next
        End If
    End Sub
End Class


